/*
    Copyright (c) 2015 digitalSTROM AG, Zurich, Switzerland

    Authors: Enrique Robledo Arnuncio, for digitalSTROM AG <era@tegulan.com>

    This file is part of vdSM.

    vdSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License.


    vdSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vdSM. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __VDSM_ROLE_H__
#define __VDSM_ROLE_H__

#include <stdbool.h>

typedef struct {
    bool collectable;
    bool collecting;
    bool master;
    bool auxiliary;
    bool noauto;
} VDSMRole;

void vdsm_role_clear(VDSMRole *role);

/**
 * Ensures that the role flags are consistent.
 *
 * Returns false if some inconsistency is found that can not be handled.
 *
 * If the collection role flags are unset, the vdSM is assumed conform
 * to the vDC API v2, and the "collectable" role flag is set to true.
 */
bool vdsm_role_sanitize(VDSMRole *role);

#endif /* __VDSM_ROLE_H__ */
