#!/usr/bin/env python
from ds485d_mock import *

import asyncore, socket, select
import time, datetime
import sys, os
import traceback, signal
import logging
import asyncore, socket, select
from threading import Thread, Timer

TIMESTMP_FMT = ("%H:%M:%S") # no %f for msecs
FORMAT = '%(asctime)s.%(msecs)03d %(name)-5s %(message)s'
logging.basicConfig(format=FORMAT, datefmt=TIMESTMP_FMT, level=logging.INFO)

#
# no two blocking c-calls in python, hence asyncore
# https://wiki.python.org/moin/GlobalInterpreterLock
#

class AsyncCore(Thread):
    log = logging.getLogger("AsyncCore")

    def run(self):
        self.log.info("AsynCore -- loop start")
        self.active = True
        while self.active:
            try:
                # check readable, writeable ever 1s, self.active every 10s
                asyncore.loop(timeout = 1, count = 10)
                #self.log.info("asyncore.loop iter")
            except select.error, e:
                self.log.info("select error nr: %d, desc %s", e[0], e[1])
            except  Exception, e:
                self.log.info("Error %s", type(e))
                print traceback.format_exc()
        self.log.info("AsynCore -- loop done")


    def stop(self):
        self.log.info("AsynCore -- stop")
        self.active = False


'''Fire up Deamons and wait till somebody, hopefully ds485p
connected'''
def fire_up_daemons(ports):
        daemons = []
        for p in ports:
            d = Daemon(p, State(p))
            daemons.append(d)

        for i in range(10):
            time.sleep(2)
            bus_clients = sum([len(d.clients) for d in daemons])
            if bus_clients == len(daemons):
                break

        if bus_clients != len(daemons):
            return False

        return daemons



g_child = None
''' fork_ds485p -- 1st thing before creating listen sockets
    loglevel  see man syslog, default LOG_NOTICE
'''
def fork_ds485p(listen_port, daemon_ports, loglevel = 5,  valgrind = True):
    global g_child

    g_child = os.fork()
    if g_child == 0:
        args = ("%s -d%d -l %d -F" % ("../ds485p", loglevel,
                                     listen_port)).split()
        for p in daemon_ports:
            args.append("tcp://localhost:%d" % p)

        if valgrind:
            args.reverse()
            args.append("--log-socket=127.0.0.1:1500")
            args.append("/usr/bin/valgrind")
            args.reverse()
            os.execv("/usr/bin/valgrind", args)
        else:
            os.execv("../ds485p", args)

def kill_ds485p():
    global g_child
    log = logging.getLogger("kill_ds485p")
    log.info(" PID %d" % g_child if g_child else -1)
    if g_child:
        os.system("kill -9 %d" % g_child)
        g_child = None

def seppuku():
    log = logging.getLogger("Seppuku")

    # kill all, also forked process by name
    os.system("pkill -9 ds485p")
    #os.system('ps ax | grep "[p]ython.*testsuite.*.py" | awk -e "{ print \$1 }" | xargs kill -9')
    # valgrind needs special care
    os.system('ps ax | grep "[.]./bin/ds485p" | awk -e "{ print \$1 }" | xargs kill -9')
    os.system('kill -9 %d' % os.getpid())
